<?php namespace Myriad\NotifyClient\Client\FluentApi;

use Myriad\NotifyClient\Client;

class NotificationFluentApi {

  private $notificationId;

  private $nsc;

  function __construct(Client $nsc, $notificationId = null) {
    $this->nsc = $nsc;
    $this->notificationId = $notificationId;
  }

  public function query($filter, $sort = null, $limit = null) {
    return $this->nsc->queryNotifications($filter, $sort, $limit);
  }

  public function create($notification) {
    return $this->nsc->createNotification($notification);
  }

  public function get($notificationId) {
    return $this->nsc->getNotification($notificationId);
  }

  public function update($notification) {
    return $this->nsc->updateNotification($notification, $this->notificationId);
  }

  public function delete($notificationId) {
    return $this->nsc->deleteNotification($notificationId);
  }
}