<?php namespace Myriad\NotifyClient\Client\FluentApi;

use Myriad\NotifyClient\Client;

class NotificationGroupRegistrantFluentApi {

  private $nsc;
  private $uid;
  private $registrantSlug;

  function __construct(Client $nsc, $uid, $registrantSlug = null) {
    $this->nsc = $nsc;
    $this->uid = $uid;
    $this->registrantSlug = $registrantSlug;
  }

  // $nsc->notificationGroups($uid)->registrants()->all();
  public function all() {
    return $this->nsc->allRegistrants($this->uid);
  }

  // $nsc->notificationGroups($uid)->registrants('primaryEmail')->get();
  public function get() {
    return $this->nsc->getRegistrant($this->uid, $this->registrantSlug);
  }

  // $nsc->notificationGroups($uid)->registrants()->createUpdate(['slug' => 'primaryEmail', 'identifier' => 'bilbo@baggins.com']);
  // $nsc->notificationGroups($uid)->registrants('primaryEmail')->createUpdate(['identifier' => 'bilbo@baggins.com']);
  public function createUpdate($registrant) {
    return $this->nsc->createUpdateRegistrant($this->uid, $registrant, $this->registrantSlug);
  }

  // $nsc->notificationGroups($uid)->registrants('primaryEmail')->delete();
  public function delete() {
    return $this->nsc->deleteRegistrant($this->uid, $this->registrantSlug);
  }

  // $nsc->notificationGroups($uid)->registrants('push')->addSubscriptions('price_alert', 'weather');
  public function addSubscriptions($val) {
    $subscriptions = is_array($val) ? $val : func_get_args();
    return $this->nsc->addSubscriptionsToRegistrant($this->uid, $this->registrantSlug, $subscriptions);
  }

  // $nsc->notificationGroups($uid)->registrants('push')->removeSubscriptions('price_alert', 'weather');
  public function removeSubscriptions($val) {
    $subscriptions = is_array($val) ? $val : func_get_args();
    return $this->nsc->removeSubscriptionsFromRegistrant($this->uid, $this->registrantSlug, $subscriptions);
  }

  // $nsc->notificationGroups('892034adf')->registrants('push')->addUpdateCustom(['key' => 'val', 'key2' => 'val2']);
  public function addUpdateCustom($custom) {
    return $this->nsc->addUpdateCustomToRegistrant($this->uid, $this->registrantSlug, $custom);
  }

  // $nsc->notificationGroups('892034adf')->registrants('push')->removeCustom(['key', 'key2']);
  public function removeCustom($val) {
    $custom = is_array($val) ? $val : func_get_args();
    return $this->nsc->removeCustomFromRegistrant($this->uid, $this->registrantSlug, $custom);
  }
}