<?php namespace Myriad\NotifyClient\Client\Helpers;

use Exception;
use Myriad\NotifyClient\Client\ValidatesAgainstConfig;
use Myriad\NotifyClient\Models\NotificationGroup;
use Myriad\NotifyClient\Utilities\BuiltWithConfig;
use Myriad\NotifyClient\Utilities\HydratesModels;

class NotificationGroupHelper {
  use BuiltWithConfig;
  use HydratesModels;
  use ValidatesAgainstConfig;

  protected function getItemClass() {
    return NotificationGroup::class;
  }

  public function makeArray($object) {
    if ($object instanceof NotificationGroup) {
      return $object->toArray();
    }
    if (is_array($object)) {
      return $object;
    }
    throw new Exception('Object must be a NotificationGroup or array');
  }

  public function validate(array $array) {
    $this->maybeAssertChannelsAreValid(array_get($array, 'channels', []));
    return true;
  }

  public function uri($addl = null) {
    return "notificationGroups" . ($addl ? "/$addl" : '');
  }
}