<?php namespace Myriad\NotifyClient\Client\Helpers;

use Exception;
use Myriad\NotifyClient\Client\Config;
use Myriad\NotifyClient\Client\ValidatesAgainstConfig;
use Myriad\NotifyClient\Models\NotificationGroupRegistrant;
use Myriad\NotifyClient\Utilities\BuiltWithConfig;
use Myriad\NotifyClient\Utilities\HydratesModels;

class NotificationGroupRegistrantHelper {

  use BuiltWithConfig;
  use HydratesModels;
  use ValidatesAgainstConfig;

  protected function getItemClass() {
    return NotificationGroupRegistrant::class;
  }

  public function makeArray($object) {
    if ($object instanceof NotificationGroupRegistrant) {
      return $object->toArray();
    }
    if (is_array($object)) {
      return $object;
    }
    throw new Exception('Object must be a NotificationGroupRegistrant or array');
  }

  public function validate(array $array) {
    $this->maybeAssertSubscriptionsAreValid(array_get($array, 'subscriptions', []));
    return true;
  }

  public function uri($uid, $addl = null) {
    return "notificationGroups/$uid/registrants" . ($addl ? "/$addl" : '');
  }
}